exception Not_yet
exception Dns_queue of int

(* asynchronous dns with cache
 * can raise Dns_Queue if not in cache *)
val my_gethostbyname : string -> Unix.inet_addr

(* is this dns call done *)
val is_done : int -> bool

(* Is this answer arrived ?
 * can raise Not_yet if the answer is not arrived yet *)
val dns_answer : int -> Unix.inet_addr

(* We're not any more interested by this request *)
val forget : int -> unit

(* read dns answers *)
val update : Unix.file_descr list -> unit

(* initialisation *)
val init_dns : unit -> Unix.file_descr
