(* state of a connexion *)
type state =
  | STARTING
  | DNS of int
  | CONNECTING
  | ALIVE
  | FINISHING

(* what are we parsing now *)
type parse =
  | CMD_LINE
  | WAIT_DNS of string * int * int
  | HEADERS
  | CONTENT

(* one connexion *)
type connexion = {
    client : Unix.file_descr;
    mutable server : Unix.file_descr;
    mutable state : state;
    mutable read_req : string;
    mutable write_req : string;
    mutable state_req : parse;
    mutable read_ans : string;
    mutable write_ans : string;
    mutable state_ans : parse
  } 

(* sockets used in the main select *)
val fread : Unix.file_descr list ref
val fwrite : Unix.file_descr list ref

(* connexions for the dns calls *)
val from_dns_fds : Unix.file_descr ref

(* what kind of output is required *)
val stats : int ref
val debug : int ref
val req_1 : bool ref
val req_2 : bool ref
val req_3 : bool ref
val ans_1 : bool ref
val ans_2 : bool ref
val ans_3 : bool ref

(* precise config : should not change *)
val buf_size : int
val dns_cache_size : int

(* standard answers *)
val forbid_url : string ref
val host_unreach : string ref
val invalid_req : string ref
val unknown_host : string ref
